"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

PPCAbstractPredicateNode subclass:#PPCNotMessagePredicateNode
	instanceVariableNames:'message'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Nodes'
!

!PPCNotMessagePredicateNode methodsFor:'accessing'!

asInlined
	^ PPCInlineNotMessagePredicateNode new
		predicate: predicate;
		message: message;
		name: name;
		yourself
!

firstCharSet
	PPCharSetPredicate on: [:e | (predicate value:e)  not ] 
!

message
	
	^ message
!

message: anObject
	
	message := anObject
! !

!PPCNotMessagePredicateNode methodsFor:'as yet unclassified'!

bodyOfPredicate: compiler
	compiler addOnLine: '(context peek ', message, ')'.
	compiler indent.
	compiler add: ' ifTrue: [ self error: '' predicate not expected'' ]'.
	compiler add: ' ifFalse: [ nil ].'.
	compiler dedent.
! !

!PPCNotMessagePredicateNode methodsFor:'comparison'!

= anotherNode
	super = anotherNode ifFalse: [ ^ false ].
	^ message = anotherNode message.
!

hash
	^ super hash bitXor: message hash
! !

